%{
#include "parse_util.h"
%}

%token T_SEMI

%left T_PLUS
%left T_TIMES

%token T_LPAREN
%token T_RPAREN
%token T_INTCONST

%%

stmts: e T_SEMI stmts { $$ = new StmtsNode($1,$3); parse_root = $$; }
	| { $$ = 0; parse_root = $$; }
;

e:	e T_PLUS e { $$ = new BinaryNode(T_PLUS,$1,$3); }
	| e T_TIMES e { $$ = new BinaryNode(T_TIMES,$1,$3); }
	| T_INTCONST { $$ = $1; }
	| T_LPAREN e T_RPAREN { $$ = new UnaryNode(T_LPAREN,$2); }
;

%%
